RDB 2: riegl::rdb::pointcloud::QueryUpdate Class Reference

| RDB 2

- Main Page
- Related Pages
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | List of all members
riegl::rdb::pointcloud::QueryUpdate Class Reference

Point update query. More...

`#include <queryUpdate.hpp>`

## Public Member Functions
| QueryUpdate ()
| Default constructor. More...
| QueryUpdate (riegl::rdb::PointcloudData *pointcloud)
| Constructor. More...
| operator bool () const
| Check if query is not null. More...
bool | valid () const
| Check if query is not null. More...
void | close ()
| Finish query. More...
void | bind (const std::string &attribute, const DataType dataType, const void *buffer, const std::int32_t stride=0)
| Bind attribute buffer. More...
template<typename ValueType >
void | bindBuffer (const std::string &attribute, const ValueType &buffer, const std::int32_t stride=0)
| Bind attribute buffer. More...
template<typename ObjectType , typename MemberPointer >
void | bindMember (const std::string &attribute, const ObjectType &object, const MemberPointer member)
| Bind attribute buffer. More...
template<typename ObjectType , typename MemberPointer >
void | bindMember (const std::string &attribute, const ObjectType &object, const MemberPointer member, const std::size_t index)
| Bind attribute buffer. More...
std::uint32_t | next (std::uint32_t count)
| Update points. More...

## Detailed Description

Point update query.

This class can be used to update (modify) attributes of existing points.

See Also
  riegl::rdb::Pointcloud::update()

Note
  You either must delete the query object or call close() before the parent Pointcloud instance is closed/deleted!

Examples:
  rdb-example-04-update-points.cpp.

Definition at line 66 of file queryUpdate.hpp.

## Constructor & Destructor Documentation

riegl::rdb::pointcloud::QueryUpdate::QueryUpdate | ( |  | ) |
| explicit

Default constructor.

Creates a null query - i.e. the query cannot be used to update points.

See Also
  riegl::rdb::Pointcloud::update()

riegl::rdb::pointcloud::QueryUpdate::QueryUpdate | ( | riegl::rdb::PointcloudData * | pointcloud | ) |
| explicit

Constructor.

Creates a query prepared for updating points.

Note
  You cannot create new QueryUpdate objects this way, use riegl::rdb::Pointcloud::update() instead.

## Member Function Documentation

void riegl::rdb::pointcloud::QueryUpdate::bind | ( | const std::string & | attribute,
|  | const DataType | dataType,
|  | const void * | buffer,
|  | const std::int32_t | stride = `0`
| ) |  |

Bind attribute buffer.

Use this function to define a source buffer for a point attribute. Exactly one buffer can be defined for an attribute (i.e. only the most recently defined buffer will be used).

You can but don't need to define a buffer for each attribute. If no buffer is defined for an attribute, it remains unchanged.

The buffer is expected to be n*s*d bytes large, where n is the number of points defined in next(), s is the size of one element as defined by 'dataType' and d is the number of attribute dimensions (elements).

Note
  This function just stores the buffer pointer - it does NOT copy the data contained in the buffer. So make sure that the buffer remains valid until you call next().
  This function expects a buffer for the point ID attribute.

See Also
  riegl::rdb::pointcloud::PointAttributes

Parameters

  [in] | attribute | attribute name
  [in] | dataType | buffer data type
  [in] | buffer | buffer location
  [in] | stride | bytes between beginnings of successive elements (0: auto)

template<typename ValueType >

void riegl::rdb::pointcloud::QueryUpdate::bindBuffer | ( | const std::string & | attribute,
|  | const ValueType & | buffer,
|  | const std::int32_t | stride = `0`
| ) |  |
| inline

Bind attribute buffer.

Use this function to define a source buffer for a point attribute. Exactly one buffer can be defined for an attribute (i.e. only the most recently defined buffer will be used).

You can but don't need to define a buffer for each attribute. If no buffer is defined for an attribute, it remains unchanged.

The buffer is expected to be n*s*d bytes large, where n is the number of points defined in next(), s is the size of one element as defined by 'dataType' and d is the number of attribute dimensions (elements).

Note
  This function just stores the buffer pointer - it does NOT copy the data contained in the buffer. So make sure that the buffer remains valid until you call next().
  This function expects a buffer for the point ID attribute.

See Also
  riegl::rdb::pointcloud::PointAttributes

Parameters

  [in] | attribute | attribute name
  [in] | buffer | buffer (data, pointer to data, std::array or std::vector)
  [in] | stride | bytes between beginnings of successive elements (0: auto)

Examples:
  rdb-example-04-update-points.cpp.

Definition at line 141 of file queryUpdate.hpp.

template<typename ObjectType , typename MemberPointer >

void riegl::rdb::pointcloud::QueryUpdate::bindMember | ( | const std::string & | attribute,
|  | const ObjectType & | object,
|  | const MemberPointer | member
| ) |  |
| inline

Bind attribute buffer.

This is a variant of bindBuffer() that allows to bind a member variable of an object as attribute buffer. The object can be part of a container that stores the objects contiguously (e.g. std::vector, std::array) and the stride is automatically derived from the object size.

See Also
  bindBuffer()

Parameters

  [in] | attribute | attribute name
  [in] | object | e.g. first object of container
  [in] | member | object member variable pointer

Definition at line 161 of file queryUpdate.hpp.

template<typename ObjectType , typename MemberPointer >

void riegl::rdb::pointcloud::QueryUpdate::bindMember | ( | const std::string & | attribute,
|  | const ObjectType & | object,
|  | const MemberPointer | member,
|  | const std::size_t | index
| ) |  |
| inline

Bind attribute buffer.

This is a variant of bindBuffer() that allows to bind a member variable of an object as attribute buffer. The object can be part of a container that stores the objects contiguously (e.g. std::vector, std::array) and the stride is automatically derived from the object size.

See Also
  bindBuffer()

Parameters

  [in] | attribute | attribute name
  [in] | object | e.g. first object of container
  [in] | member | object member variable pointer
  [in] | index | index for array-like object members

Definition at line 175 of file queryUpdate.hpp.

void riegl::rdb::pointcloud::QueryUpdate::close | ( |  | ) |

Finish query.

Call this function when done with updating points.

std::uint32_t riegl::rdb::pointcloud::QueryUpdate::next | ( | std::uint32_t | count | ) |

Update points.

Use this function to actually read the point attributes from all defined buffers and update the points in the database.

Afterwards you may re-fill the buffers or define new buffers with bind() and call next() again until all points have been updated.

Remarks
  It is assumed that the points are given in the exact same order as returned by the select query (riegl::rdb::pointcloud::QuerySelect). If the points are given in a different order, the update will still work but may take more time to finish. Of course it is not required to update all points (you don't need to provide points that you do not want to update).

Note
  IEEE-754 "NaN" values contained in floating point source buffers are ignored and the attribute's default value is used instead. Furthermore IEEE-754 "Infinity" values will always cause next() to fail with error code 10414, i.e. riegl::rdb::Error::QueryAttributeValueOutOfRange.
  Since version 2.4.2, unit vector point attributes (e.g. "riegl.direction") are automatically normalized (divided by the vector length) on insertion. This is done for all point attributes that meet the following requirements: `length` is 3, `minimumValue` is -1, `maximumValue` is 1, `resolution` is not 1, `scaleFactor` is 1, `unitSymbol` is empty, `invalidValue` is undefined and `tags` contains the "direction" tag but not the "do-not-normalize" tag.

Warning
  If you want to modify the primary point attribute (usually the point coordinates), you must either read all points with a select query (class QuerySelect) first and update them later, or use two different instances of riegl::rdb::Pointcloud on the same database and use one instance to read (select) and the other instance to write (update) the points. In other words: It is not allowed to alternately call next() on an instance of QuerySelect and an instance of QueryUpdate if both were started on the same Pointcloud instance and the goal is to modify the primary point attribute.

Returns
  the number of points updated

Parameters

  [in] | count | size of source buffers in terms of points

Examples:
  rdb-example-04-update-points.cpp.

riegl::rdb::pointcloud::QueryUpdate::operator bool | ( |  | ) | const

Check if query is not null.

See Also
  valid()

bool riegl::rdb::pointcloud::QueryUpdate::valid | ( |  | ) | const

Check if query is not null.

A null query cannot be used to update points.

The documentation for this class was generated from the following file:

- riegl/rdb/pointcloud/queryUpdate.hpp